#!/usr/bin/env node
var path = require("path");
var fs = require("fs");
var argvs = require('./src/parseArgs.js');
var unzip = require("./src/unzip.js");
var replaceindex = require("./src/replaceindex.js");
var setConst = require("./src/setConst.js");
var concatFiles = require("./src/concatFiles.js");
var ug = require("./src/ug.js");
var removeOriginJs = require("./src/removeOriginJs.js");
var filterCanvasName = require("./src/filterCanvasName.js");
var confuseCode = require("./src/confuseCode.js");
var getAllJsFileName = require("./src/getAllJsFileName.js");
var supportWebGL = require("./src/supportWebGL.js");
var wxshare = require("./src/wxShare.js");
var addStat = require("./src/addStat");
var handleResize = require("./src/handleResize");
var generatePackageZip = require("./src/generatePackageZip");
var addStatTimeStamps = require("./src/addStatForGetTimestamps");

global._DEFAULT_DIR_NAME = "web";
global._DEFAULT_AIO_NAME = "aio";
global.argvs = argvs;
global._WXSHARE_CONFIG = "_WXSHARE_CONFIG";
global._WXSHARE_CDN = [
    "https://cdn.weshape3d.com/assets/social-sdk.js",
    "https://cdn.weshape3d.com/assets/social.js"
];

// console.log(argvs)
if(!argvs.filePath) return console.log("false\nfilePath is not supported");
global.cwd = path.resolve(argvs.filePath,"../"); //当前工作目录;

unzip(argvs.filePath) // unzip
.then(setConst) // extract const.js
.then(addStatTimeStamps) // 添加统计时间戳
// .then(handleResize) // 添加横屏设置
.then(supportWebGL) //modify not support WebGL 
.then(filterCanvasName) //replace playcanvas
.then(concatFiles) // concat files to aio.js
.then(removeOriginJs)
.then(ug) // uglify *.js to *.min.js
.then(replaceindex)
.then(confuseCode)
.then(addStat) // 加入统计代码
.then(generatePackageZip) //生成客户端离线包
.then(wxshare) //微信分享相关
.then(() => {
    console.log("true");
    // fs.unlinkSync(argvs.filePath); //删除zip包
})
.catch(err => {
    console.log("false\n"+err);
})