var filesOrder = require("./filesOrder.js")();
var fs = require("fs");
var path = require("path");
var resetLoadScript = require("./resetLoadScript.js");

/**
 *
 *
 * @param {*} index 文件index
 * @param {*} cwd 目录
 * @param {*} chunks 拼接
 * @param {*} size 文件size
 * @param {*} resolve 
 * @param {*} reject
 * @returns
 */
var join = function (index,cwd,chunks,size,resolve,reject){
        if(index === filesOrder.length) return writeAioJS(cwd,chunks,resolve);
        if(filesOrder[index] === "playcanvas-stable.min.js") filesOrder[index] = "engine.min.js";
        var file = path.resolve(cwd,_DEFAULT_DIR_NAME,filesOrder[index]);
        fs.stat(file,function(err,stats){
            if(err){
                reject(err);
            }else{
                var isFile = stats.isFile();
                if(isFile){
                    var content = fs.readFileSync(file,'utf-8');
                    chunks.push(content);
                    size += content.length;
                    join(++index,cwd,chunks,size,resolve,reject);
                }else{
                    reject('this is not a file');
                }
            }
        });
    }
// 将合并的数据写到 aio.js；
/**
 *
 *
 * @param {*} cwd
 * @param {*} chunks
 * @param {*} resolve
 */
var writeAioJS = function(cwd,chunks,resolve){
    var data = '';
    for(var i = 0, l = chunks.length; i < l; i++){
        var chunk = chunks[i];
        data += chunk.toString();
    }
    var aioJsPath = path.resolve(cwd,_DEFAULT_DIR_NAME,_DEFAULT_AIO_NAME+".min.js");
    fs.writeFileSync(aioJsPath,data);
    resolve();
}

module.exports = function(){
    return new Promise(function(resolve,reject){
        if(!argvs.joinFiles) return resolve();
        fs.exists(path.resolve(cwd, _DEFAULT_DIR_NAME, "config.json"), function (ex) {
            if (ex) {
                try{
                    var configStr = fs.readFileSync(path.resolve(cwd, _DEFAULT_DIR_NAME, "config.json"));
                    var configJson = JSON.parse(configStr);
                    var libraries = configJson.application_properties.libraries;
                    for (var i = 0; i < libraries.length; i++){
                        filesOrder.push(libraries[i]);
                    }
                }catch(e){
                    return reject("读取config.json出错",+e);
                }
            }
        })
        fs.exists(path.resolve(cwd, _DEFAULT_DIR_NAME,"__game-scripts.js"),function(ex){
            if(ex){
                filesOrder.push("__game-scripts.js");
            }
        })
        resetLoadScript();
        var chunks = [];
        var size = 0;
        join(0,cwd,chunks,size,resolve,reject);
    })
}
