var fs = require("fs");
var path =require("path");
var _7z = require("7zip")['7z'];
var child_process = require("child_process");
var crypto = require("crypto");
var md5 = crypto.createHash("md5");
var sha1 = crypto.createHash("sha1");
var salt = "ygolonhcetlatigidepahSeW";
var cheerio = require("cheerio");

var commonCode = `
<script>
    document.addEventListener('touchmove', function (e) {
        e.preventDefault();
    }, {passive: false});
</script>
`;

var createPass = function(projectId, clientId) {
    var str1 = projectId + "" + clientId;
    str2 = (str1 + salt).match(/(\w{1,3})/g).reverse().join("");
    md5.update(str2);
    var md5Value = md5.digest("hex").substr(8, 16);
    sha1.update(md5Value);
    var pass = sha1.digest("hex");
    return pass;
}

// 将index.html文件复制为TempIndex.html,将index.html修改为需要打包到zip包的格式，将TempIndex.html文件修改回index.html文件
var replaceHTMLFile = function(){
    var htmlFileOriginPath = path.resolve(cwd,"web/index.html");
    var htmlContent = fs.readFileSync(htmlFileOriginPath);
    var $ = cheerio.load(htmlContent, { decodeEntities: false });
    $("script").eq(0).remove();
    $("head").prepend(commonCode);
    fs.writeFileSync(htmlFileOriginPath, $.html(), { encoding: 'utf8', flag: 'w' });
    return htmlContent;
    // fs.renameSync(htmlFileTempPath, htmlFileOriginPath);
};

module.exports = function (){
    return new Promise(function(resolve,reject){
        if (!argvs.clientID) return reject("clientID is not supported");
        if (!argvs.projectID) return reject("projectID is not supported");
        var zipPath = path.resolve(cwd, "package.zip");
        var hasZipFile = fs.existsSync(zipPath);
        if (hasZipFile) {
            fs.unlinkSync(zipPath);
        }
        var files = fs.readdirSync(cwd);
        var filteredFiles = files.filter(item => {
            return item != "__MACOSX" && item != "zoom.zip" && item != "package.zip";
        })
        var _paths = ""; 
        filteredFiles.forEach(item => {
            _paths += path.resolve(cwd, item);
            _paths += " ";
        })
        // var webDir = path.resolve(cwd,"web");
        var packagePath = path.resolve(cwd,"package.zip");
        var originHtmlContent = replaceHTMLFile();
        child_process.exec(_7z + " a " + packagePath + " " + _paths +" -p" + createPass(argvs.projectID, argvs.clientID), function (err, stdout, stderr) {
            if (err) return reject(err);
            else {
                fs.writeFileSync(path.resolve(cwd, "web/index.html"), originHtmlContent);
                resolve();
            }
        });
    });
};