var cheerio = require("cheerio");
var fs = require("fs");
var path = require("path");
var _OLD_NAME = "playcanvas-stable.min.js", _OLD_NAME2 = "engine.js", _NEW_NAME = "engine.min.js";

var renameCanvsStableJS = function($script){
    if ($script.attr("src") === _OLD_NAME) {
        var oldFilePath = path.resolve(cwd, _DEFAULT_DIR_NAME, _OLD_NAME);
        var newFilePath = path.resolve(cwd, _DEFAULT_DIR_NAME, _NEW_NAME);
        $script.attr("src","engine.min.js");
        fs.renameSync(oldFilePath, newFilePath);
    }
    if ($script.attr("src") === _OLD_NAME2) {
        var oldFilePath = path.resolve(cwd, _DEFAULT_DIR_NAME, _OLD_NAME2);
        var newFilePath = path.resolve(cwd, _DEFAULT_DIR_NAME, _NEW_NAME);
        $script.attr("src", "engine.min.js");
        fs.renameSync(oldFilePath, newFilePath);
    }
}

module.exports = function(){
    return new Promise(function(resolve,reject){
        var indexHTMLPath = path.resolve(cwd,_DEFAULT_DIR_NAME,"index.html");
        var indexHtml = fs.readFileSync(indexHTMLPath,'utf-8');
        var $ = cheerio.load(indexHtml, {
            withDomLvl1: false,
            normalizeWhitespace: false,
            xmlMode: false,
            decodeEntities: false
        });
        var scripts = $('script');
        for (var i = 0; i < scripts.length; i++) {
            var $script = scripts.eq(i);
            let htmlTxt = $script.html();
            renameCanvsStableJS($script);
            if(htmlTxt) {
                $script.html('').attr("src","const.js");
                fs.writeFileSync(path.resolve(cwd,_DEFAULT_DIR_NAME,"const.js"),htmlTxt,{encoding:'utf8', flag:'w'});
                fs.writeFileSync(path.resolve(cwd,_DEFAULT_DIR_NAME,"index.html"),$.html(),{encoding:'utf8', flag:'w'});
                resolve();
                return;
            } else if ("__settings__.js" === $script.attr("src")){

                var html = fs.readFileSync(path.resolve(cwd, _DEFAULT_DIR_NAME, "__settings__.js"), 'utf-8');
                html += fs.readFileSync(path.resolve(cwd, _DEFAULT_DIR_NAME, "__modules__.js"), 'utf-8');
                fs.writeFileSync(path.resolve(cwd, _DEFAULT_DIR_NAME, "const.js"), html, { encoding: 'utf8', flag: 'w' });
                fs.writeFileSync(path.resolve(cwd, _DEFAULT_DIR_NAME, "index.html"), $.html(), { encoding: 'utf8', flag: 'w' });
                resolve();
                return;
            }
        }
        reject("index.html dose not include config");
    })
}
