var unzip = require("unzip2");
var fs = require("fs");
var path = require("path");

var _OLD_NAME = "engine.js", _NEW_NAME = "playcanvas-stable.min.js";
var deleteFolder = function (path) {
    var files = [];
    if (fs.existsSync(path)) {
        files = fs.readdirSync(path);
        files.forEach(function (file, index) {
            var curPath = path + "/" + file;
            if (fs.statSync(curPath).isDirectory()) {
                deleteFolder(curPath);
            } else {
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
}

module.exports = function (zipPath) {
    return new Promise(function (resolve, reject) {
        // 解析zip文件绝对路径
        // var zipPath = path.resolve(cwd,'Telstar18--2018世界杯官方用球.zip');
        // console.log(path.resolve(zipPath,'../')); 获取文件所在文件夹
        // 判断文件是否存在
        fs.stat(zipPath, function (err, stats) {
            if (err) reject("no such file", err)
        });
        // 提取文件到web文件夹
        deleteFolder(path.resolve(cwd, _DEFAULT_DIR_NAME)); // 删除已有web文件夹
        var stream =  fs.createReadStream(zipPath);
        stream.pipe(unzip.Extract({ path: path.resolve(cwd, _DEFAULT_DIR_NAME) }))
            .on("close", function () { //提取完毕
                fs.exists(path.resolve(cwd, "web/index.html"), function (exists) {
                    if (exists) {
                        // 新项目playcanvas直接下载
                        return resolve();
                    } else {
                        // 老项目，之前手动打包，多一层web,且已手动修改playcanvas-stable为engine
                        deleteFolder(path.resolve(cwd, _DEFAULT_DIR_NAME)); // 删除上一步打包的web文件夹
                        fs.createReadStream(zipPath).pipe(unzip.Extract({ path: path.resolve(cwd) }))
                            .on("close", function () {
                                //fs.renameSync(path.resolve(cwd, _DEFAULT_DIR_NAME, _OLD_NAME), path.resolve(cwd, _DEFAULT_DIR_NAME, _NEW_NAME));
                                resolve();
                            })
                            .on("error", function (err) {
                                reject("failed to unzip "+err);
                            })
                    }
                })
            })
            .on('error', function (err) { // 提取失败
                reject("failed to unzip "+err);
            })


    })
};
